#!/bin/bash

set -e

if [[ "$(uname)" == "Darwin" ]]; then
    # at least for Travis's compiler, -O2 fails the unit tests
    export CXXFLAGS="${CXXFLAGS} -O1"
else
    export CXXFLAGS="${CXXFLAGS} ${CFLAGS} -O2"
fi
export CXXFLAGS="${CXXFLAGS} -DNDEBUG"

mkdir build
cd build
cmake .. \
    -DCMAKE_INSTALL_PREFIX="$PREFIX" \
    -DCMAKE_PREFIX_PATH="$PREFIX" \
    -DCMAKE_CXX="${CXX}" \
    -DCMAKE_CC="${CC}" \
    -DCMAKE_POSITION_INDEPENDENT_CODE=1 \
    -DCMAKE_C_FLAGS="${CFLAGS}" \
    -DCMAKE_CXX_FLAGS="${CXXFLAGS}" \
    -DCMAKE_SHARED_LINKER_FLAGS="${LDFLAGS}" \
    -DBUILD_SHARED_LIBS=1

make -j${CPU_COUNT} ${VERBOSE_CM}

make install

#inside container, the libs are copied into lib64, not lib, this fixes it
if [ -d ${PREFIX}/lib64 ]; then
  cp -r ${PREFIX}/lib64/* ${PREFIX}/lib
  rm -rf ${PREFIX}/lib64
fi
